﻿using Microsoft.EntityFrameworkCore;
using Model;
using System;
using System.Collections.Generic;
using System.Text;

namespace DBContext
{
    public class SongContext : DbContext
    {
        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            optionsBuilder.UseMySql("CONNECTIONSTRING");
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            // Song (n) - Genre (1)
            modelBuilder.Entity<Song>()
                .HasOne(s => s.Genre)
                .WithMany(g => g.Songs)
                .HasForeignKey(s => s.GenreID);

            //Song (n) - List (1)
            modelBuilder.Entity<Song>()
                .HasOne(s => s.List)
                .WithMany(l => l.Songs)
                .HasForeignKey(s => s.ListID);

            //Song (n) - Album (1)
            modelBuilder.Entity<Song>()
                .HasOne(s => s.Album)
                .WithMany(a => a.Songs)
                .HasForeignKey(s => s.AlbumID);

            //Song (n) - Interpret (n)  (mit Zwischentabelle SongInterpret)
            modelBuilder.Entity<SongInterpret>()
                .HasOne(si => si.Song)
                .WithMany(s => s.SongInterprets)
                .HasForeignKey(si => si.SongID);
            modelBuilder.Entity<SongInterpret>()
                .HasOne(si => si.Interpret)
                .WithMany(i => i.SongInterprets)
                .HasForeignKey(si => si.InterpretID);

            //List (n) - Status (1)
            modelBuilder.Entity<List>()
                .HasOne(l => l.Status)
                .WithMany(s => s.Lists)
                .HasForeignKey(l => l.StatusID);
        }
    }
}
